//
//  HITTransaction.h
//  HITModule
//
//  Created by Developer on 20/06/16.
//  Copyright © 2016 Payment Express. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "HITTransactionDetails.h"
#import "HITTransactionResultDetails.h"
#import "HITTransactionRecoveryDetails.h"
#import "HITWindowStyle.h"

typedef enum {
    HITTransactionTypePurchase,
    HITTransactionTypeAuth,
    HITTransactionTypeComplete,
    HITTransactionTypeRefund,
    HITTransactionTypeVoid
} HITTransactionType;

typedef enum {
    HITTransactionLogEntryRequestContent,
    HITTransactionLogEntryResponseContent,
    HITTransactionLogEntryError,
    HITTransactionLogEntryInfo
} HITTransactionLogEntryType;

typedef void(^HITTransactionResultHandler)(HITTransactionResultDetails* _Nonnull resultDetails);
typedef void(^HITTransactionSignatureReceiptHandler)(NSString* _Nonnull receipt);
typedef void(^HITTransactionDebugLogHandler)(HITTransactionLogEntryType entryType, NSString* _Nonnull text);

@interface HITTransaction : NSObject

+ (void) setWindowStyle: (HITWindowStyle * _Nullable)windowStyle;
+ (void) setDebugMode: (BOOL)enableDebugMode;
+ (void) setDebugLogHandler: (HITTransactionDebugLogHandler _Nullable)handler;

+ (void) startTransaction: (HITTransactionDetails * _Nonnull)txnDetails
                  txnType: (HITTransactionType)txnType
                 parentVC: (UIViewController * _Nonnull)parentVC
                   useUAT: (BOOL)useUAT
            resultHandler: (HITTransactionResultHandler _Nonnull)resultHandler
  signatureReceiptHandler: (HITTransactionSignatureReceiptHandler _Nullable)signatureReceiptHandler;

+ (void) recoverTransaction: (HITTransactionRecoveryDetails * _Nonnull)txnRecoveryDetails
                   parentVC: (UIViewController * _Nonnull)parentVC
                     useUAT: (BOOL)useUAT
              resultHandler: (HITTransactionResultHandler _Nonnull)resultHandler
    signatureReceiptHandler: (HITTransactionSignatureReceiptHandler _Nullable)signatureReceiptHandler;


+ (NSString * _Nonnull) getModuleVersion;

@end
